## duktape 2.0.0

=== debugger/Makefile ===
NODE:=$(shell { command -v nodejs || command -v node; } 2>/dev/null)
DUKLUV:=$(shell command -v dukluv 2>/dev/null)

# Try to get a useful default --source-dirs which works both in the Duktape
# repo and in the distributable.  We don't want to add '..' because it would
# scan a lot of undesired files in the Duktape repo (e.g. test262 testcases).
ifeq ($(wildcard ../tests/ecmascript/*.js),)
SOURCEDIRS:=../
else
SOURCEDIRS:=../tests/ecmascript
endif

.PHONY: all
all: run

.PHONY: run
run: node_modules static/socket.io-1.2.0.js static/jquery-1.11.1.min.js static/reset.css static/jquery-ui.min.js static/jquery-ui.min.css static/images
	"$(NODE)" duk_debug.js --source-dirs=$(SOURCEDIRS)

rundebug: node_modules static/socket.io-1.2.0.js static/jquery-1.11.1.min.js static/reset.css static/jquery-ui.min.js static/jquery-ui.min.css static/images
	"$(NODE)" duk_debug.js --source-dirs=$(SOURCEDIRS) --verbose --log-messages /tmp/dukdebug-messages --dump-debug-pretty /tmp/dukdebug-pretty

.PHONY: runproxynodejs
runproxynodejs: node_modules static/socket.io-1.2.0.js static/jquery-1.11.1.min.js static/reset.css static/jquery-ui.min.js static/jquery-ui.min.css static/images
	@echo "Running Node.js based debug proxy"
	"$(NODE)" duk_debug.js --json-proxy

.PHONY: runproxydukluv
runproxydukluv: duk_debug_meta.json
	@echo "Running Dukluv based debug proxy (you may need to edit DUKLUV in the Makefile)"
	"$(DUKLUV)" duk_debug_proxy.js --log-level 2 --metadata duk_debug_meta.json --readable-numbers

.PHONY: runproxy
runproxy: runproxydukluv

.PHONY: clean
clean:
	@rm -f static/socket.io-1.2.0.js
	@rm -f static/jquery-1.11.1.min.js
	@rm -f static/jquery.syntaxhighlighter.min.js
	@rm -f static/jquery.snippet.min.js
	@rm -f static/jquery.snippet.min.css
	@rm -f static/prefixfree.min.js
	@rm -f static/reset.css
	@rm -f static/jquery-ui.min.js
	@rm -f static/jquery-ui.min.css
	@rm -rf static/images
	@rm -f jquery-ui-1.11.2.zip
	@rm -rf jquery-ui-1.11.2
	@rm -rf node_modules
	@rm -f duk_debug_meta.json

node_modules:
	npm install

duk_debug_meta.json:
	python ../tools/merge_debug_meta.py --output $@ \
		--class-names duk_classnames.yaml \
		--opcodes duk_opcodes.yaml \
		--debug-commands duk_debugcommands.yaml \
		--debug-errors duk_debugerrors.yaml

static/socket.io-1.2.0.js:
	wget -O $@ http://cdn.socket.io/socket.io-1.2.0.js

static/jquery-1.11.1.min.js:
	wget -O $@ http://code.jquery.com/jquery-1.11.1.min.js

# http://balupton.github.io/jquery-syntaxhighlighter/demo/
static/jquery.syntaxhighlighter.min.js:
	wget -O $@ http://balupton.github.com/jquery-syntaxhighlighter/scripts/jquery.syntaxhighlighter.min.js

# http://steamdev.com/snippet/
static/jquery.snippet.min.js:
	wget -O $@ http://steamdev.com/snippet/js/jquery.snippet.min.js
static/jquery.snippet.min.css:
	wget -O $@ http://steamdev.com/snippet/css/jquery.snippet.min.css

# http://prismjs.com/
# http://prismjs.com/plugins/line-highlight/
#
# XXX: prism download manually?

# https://raw.github.com/LeaVerou/prefixfree/gh-pages/prefixfree.min.js
static/prefixfree.min.js:
	wget -O $@ https://raw.github.com/LeaVerou/prefixfree/gh-pages/prefixfree.min.js

# http://meyerweb.com/eric/tools/css/reset/
static/reset.css:
	wget -O $@ http://meyerweb.com/eric/tools/css/reset/reset.css

jquery-ui-1.11.2.zip:
	wget -O $@ http://jqueryui.com/resources/download/jquery-ui-1.11.2.zip
jquery-ui-1.11.2: jquery-ui-1.11.2.zip
	unzip $<
static/jquery-ui.min.js: jquery-ui-1.11.2
	cp jquery-ui-1.11.2/jquery-ui.min.js $@
static/jquery-ui.min.css: jquery-ui-1.11.2
	cp jquery-ui-1.11.2/jquery-ui.min.css $@
static/images: jquery-ui-1.11.2
	cp -r jquery-ui-1.11.2/images static/

## duktape 1.5.0

=== debian/changelog ===
duktape (1.5.0-1) unstable; urgency=medium

  * Initial release (Closes: #827773)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 20 Jun 2016 21:26:11 +0200

=== debian/control ===
Source: duktape
Section: interpreters
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>=9)
Standards-Version: 3.9.8
Homepage: http://duktape.org
#Vcs-Git: git://anonscm.debian.org/collab-maint/duktape.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/duktape.git

Package: duktape
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: embeddable Javascript engine
 Duktape is an embeddable Javascript engine, with a focus on portability 
 and compact footprint.
 .
 Duktape is easy to integrate into a C/C++ project: add duktape.c, duktape.h, 
 and duk_config.h to your build, and use the Duktape API to call Ecmascript 
 functions from C code and vice versa.
 .
 The main features are
    - Embeddable, portable, compact: can run on platforms with 
      256kB flash and 64kB system RAM
    - Ecmascript E5/E5.1 compliant, some features borrowed from 
      Ecmascript E6
    - Khronos/ES6 TypedArray and Node.js Buffer bindings
    - Built-in debugger
    - Built-in regular expression engine
    - Built-in Unicode support
    - Minimal platform dependencies
    - Combined reference counting and mark-and-sweep garbage 
      collection with finalization
    - Custom features like coroutines, built-in logging framework, 
      and built-in CommonJS-based module loading framework
    - Property virtualization using a subset of Ecmascript E6 Proxy 
      object
    - Bytecode dump/load for caching compiled functions
 .
 This package contains a commandline duk interpreter

Package: duktape-dev
Architecture: all
Depends: ${misc:Depends}
Description: embeddable Javascript engine, development files
 Duktape is an embeddable Javascript engine, with a focus on portability 
 and compact footprint.
 .
 Duktape is easy to integrate into a C/C++ project: add duktape.c, duktape.h, 
 and duk_config.h to your build, and use the Duktape API to call Ecmascript 
 functions from C code and vice versa.
 .
 This package contains all source files to use in own projects.

## duktape 2.0.0

=== debian/changelog ===
duktape (2.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 24 Jan 2017 19:12:39 +0100

duktape (1.6.0-1) unstable; urgency=medium

  * new upstream version
  * debian/control: add VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 12 Dec 2016 18:30:11 +0100

duktape (1.5.1-1) unstable; urgency=medium

  * new upstream version
  * debian/control: move maintainer to debian-iot-team

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 15 Oct 2016 11:30:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: duktape
 Section: interpreters
 Priority: optional
-Maintainer: Thorsten Alteholz <debian@alteholz.de>
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper (>=9)
 Standards-Version: 3.9.8
 Homepage: http://duktape.org
-#Vcs-Git: git://anonscm.debian.org/collab-maint/duktape.git
-#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/duktape.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/duktape.git
+Vcs-Git: https://anonscm.debian.org/git/debian-iot/duktape.git
 
 Package: duktape
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


# does not seem to work here, so no debug stuff
export DEB_BUILD_OPTIONS=noddebs

%:
	dh $@ 

override_dh_auto_build:
	make -f Makefile.sharedlibrary
	make -f Makefile.cmdline
	dh_auto_build

override_dh_auto_clean:
	rm -f duk
	rm -f libduktaped.so.*
	rm -f libduktape.so.*
	dh_auto_clean

## duktape 2.1.1

=== debian/changelog ===
duktape (2.1.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: set standard to 4.0.1 (no changes)
  * debian/rules: replace DH_BUILD_OPTIONS by DH_BUILD_MAINT_OPTIONS

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 13 Aug 2017 20:03:07 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper (>=9)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Homepage: http://duktape.org
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/duktape.git
 Vcs-Git: https://anonscm.debian.org/git/debian-iot/duktape.git

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 
 # does not seem to work here, so no debug stuff
-export DEB_BUILD_OPTIONS=noddebs
+export DEB_BUILD_MAINT_OPTIONS=noddebs
 
 %:
 	dh $@

## duktape 2.2.0

=== extras/alloc-pool/Makefile ===
# For manual testing; say 'make' in extras/alloc-pool and run ./test.

DEFS=
#DEFS+='-DDUK_ALLOC_POOL_DEBUG'

.PHONY: test
test:
	rm -rf ./prep
	echo 'DUK_USE_FATAL_HANDLER:' > opts.yaml
	echo '  verbatim: "#define DUK_USE_FATAL_HANDLER(udata,msg) my_fatal((msg))"' >> opts.yaml
	python2 ../../tools/configure.py \
		--output-directory ./prep \
		--option-file ./opts.yaml \
		--fixup-line 'extern void my_fatal(const char *msg);'
	gcc -std=c99 -Wall -Wextra -m32 -Os -otest \
		-I./prep ./prep/duktape.c \
		$(DEFS) \
		duk_alloc_pool.c test.c \
		-lm
	./test 'print("foo", "bar", 1, 2, 3)'
	./test 'alert("foo", "bar", 1, 2, 3)'

.PHONY: ptrcomptest
ptrcomptest:
	rm -rf ./prep
	echo 'DUK_USE_FATAL_HANDLER:' > opts.yaml
	echo '  verbatim: "#define DUK_USE_FATAL_HANDLER(udata,msg) my_fatal((msg))"' >> opts.yaml
	python2 ../../tools/configure.py \
		--output-directory ./prep \
		--option-file ./opts.yaml \
		--fixup-line 'extern void my_fatal(const char *msg);' \
		--option-file ../../config/examples/low_memory.yaml \
		--option-file ptrcomp.yaml \
		--fixup-file ptrcomp_fixup.h
	gcc -std=c99 -Wall -Wextra -m32 -Os -optrcomptest \
		-I. -I./prep ./prep/duktape.c \
		$(DEFS) \
		duk_alloc_pool.c test.c \
		-lm
	./ptrcomptest 'print("foo", "bar", 1, 2, 3)'
	./ptrcomptest 'alert("foo", "bar", 1, 2, 3)'

=== extras/console/Makefile ===
# For manual testing; say 'make' in extras/print-alert and run ./test.

.PHONY: test
test:
	gcc -std=c99 -Wall -Wextra -o $@ -I../../src/ -I. ../../src/duktape.c duk_console.c test.c -lm
	./test 'console.assert(true, "not shown");'
	./test 'console.assert(false, "shown", { foo: 123 });'
	./test 'console.log(1, 2, 3, { foo: "bar" });'
	./test 'a={}; b={}; a.ref=b; console.log(a,b); b.ref=a; console.log(a,b)'  # circular ref
	./test 'console.trace(1, 2, 3)'
	./test 'console.dir({ foo: 123, bar: [ "foo", "bar" ]});'

=== extras/duk-v1-compat/Makefile ===
# For manual testing; say 'make' in extras/duk-v1-compat and run ./test.

.PHONY: test
test:
	gcc -std=c99 -Wall -Wextra -o $@ -I../../src/ -I. ../../src/duktape.c duk_v1_compat.c test.c -lm
	./test

=== extras/logging/Makefile ===
# For manual testing; say 'make' in extras/logging and run ./test.
.PHONY: test
test:
	gcc -std=c99 -Wall -Wextra -otest -I../../src ../../src/duktape.c duk_logging.c test.c -lm
	./test 'L = new Duktape.Logger(); L.trace("testing"); L.l = 0; L.trace("testing 2");'
	./test 'L = new Duktape.Logger(); L.debug("testing"); L.l = 1; L.debug("testing 2");'
	./test 'L = new Duktape.Logger(); L.info("testing");'
	./test 'L = new Duktape.Logger(); L.warn("testing");'
	./test 'L = new Duktape.Logger(); L.error("testing");'
	./test 'L = new Duktape.Logger(); L.fatal("testing");'
	./test 'L = new Duktape.Logger(); L.info("testing"); L.n = "loggerName"; L.info("new name");'
	./test 'L = new Duktape.Logger("argname"); L.info("testing");'

=== extras/minimal-printf/Makefile ===
# Just for manual testing
.PHONY: test
test: duk_minimal_printf.c
	gcc -std=c99 -Wall -Wextra -fno-stack-protector -m32 -Os -fomit-frame-pointer -otest duk_minimal_printf.c test.c
	./test

=== extras/print-alert/Makefile ===
# For manual testing; say 'make' in extras/print-alert and run ./test.
.PHONY: test
test:
	gcc -std=c99 -Wall -Wextra -otest -I../../src ../../src/duktape.c duk_print_alert.c test.c -lm
	./test 'print("foo", "bar", 1, 2, 3)'
	./test 'alert("foo", "bar", 1, 2, 3)'

=== debian/changelog ===
duktape (2.2.0-3) unstable; urgency=medium

  * add pkg-config file (Closes: #882379)

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 24 Nov 2017 19:23:21 +0200

duktape (2.2.0-2) unstable; urgency=medium

  * add correct library link to dev-package (Closes: #879858)

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 26 Oct 2017 19:23:21 +0200

duktape (2.2.0-1) unstable; urgency=medium

  * New upstream release
  * debian/control: set standard to 4.1.1 (no changes)
  * debian/control: use dh10
  * add library package (Closes: #872040)

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 25 Oct 2017 19:16:35 +0200

=== debian/control ===
Source: duktape
Section: interpreters
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>=10)
	, dh-exec
Standards-Version: 4.1.1
Homepage: http://duktape.org
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/duktape.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/duktape.git

Package: duktape
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: embeddable Javascript engine
 Duktape is an embeddable Javascript engine, with a focus on portability
 and compact footprint.
 .
 Duktape is easy to integrate into a C/C++ project: add duktape.c, duktape.h,
 and duk_config.h to your build, and use the Duktape API to call Ecmascript
 functions from C code and vice versa.
 .
 The main features are
    - Embeddable, portable, compact: can run on platforms with
      256kB flash and 64kB system RAM
    - Ecmascript E5/E5.1 compliant, some features borrowed from
      Ecmascript E6
    - Khronos/ES6 TypedArray and Node.js Buffer bindings
    - Built-in debugger
    - Built-in regular expression engine
    - Built-in Unicode support
    - Minimal platform dependencies
    - Combined reference counting and mark-and-sweep garbage
      collection with finalization
    - Custom features like coroutines, built-in logging framework,
      and built-in CommonJS-based module loading framework
    - Property virtualization using a subset of Ecmascript E6 Proxy
      object
    - Bytecode dump/load for caching compiled functions
 .
 This package contains a commandline duk interpreter

Package: duktape-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
	, libduktape202 (= ${binary:Version})
Description: embeddable Javascript engine, development files
 Duktape is an embeddable Javascript engine, with a focus on portability
 and compact footprint.
 .
 Duktape is easy to integrate into a C/C++ project: add duktape.c, duktape.h,
 and duk_config.h to your build, and use the Duktape API to call Ecmascript
 functions from C code and vice versa.
 .
 This package contains all source files to use in own projects.

Package: libduktape202
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}
	, ${misc:Depends}
Description: embeddable Javascript engine, library
 Duktape is an embeddable Javascript engine, with a focus on portability
 and compact footprint.
 .
 Duktape is easy to integrate into a C/C++ project: add duktape.c, duktape.h,
 and duk_config.h to your build, and use the Duktape API to call Ecmascript
 functions from C code and vice versa.
 .
 This package contains the shared library.

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# HTTP site (basic)
http://duktape.org/download.html \
 duktape-([\d\.]+)\.tar\.xz debian uupdate

## duktape 2.3.0

=== debian/changelog ===
duktape (2.3.0-1) unstable; urgency=medium

  * New upstream release
  * add symbols file
  * add debug symbols for dbg package

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 14 Aug 2018 22:12:45 +0200

duktape (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: set standard to 4.1.5 (no changes)
  * debian/control: use dh11
  * debian/control: use salsa URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 07 Jul 2018 10:52:52 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
-Build-Depends: debhelper (>=10)
+Build-Depends: debhelper (>=11)
 	, dh-exec
-Standards-Version: 4.1.1
+Standards-Version: 4.1.5
 Homepage: http://duktape.org
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/duktape.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/duktape.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/duktape
+Vcs-Git: https://salsa.debian.org/debian-iot-team/duktape.git
 
 Package: duktape
 Architecture: any
@@ -45,7 +45,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
-	, libduktape202 (= ${binary:Version})
+	, libduktape203 (= ${binary:Version})
 Description: embeddable Javascript engine, development files
  Duktape is an embeddable Javascript engine, with a focus on portability
  and compact footprint.
@@ -56,9 +56,10 @@
  .
  This package contains all source files to use in own projects.
 
-Package: libduktape202
+Package: libduktape203
 Architecture: any
 Multi-Arch: same
+Section: libs
 Depends: ${shlibs:Depends}
 	, ${misc:Depends}
 Description: embeddable Javascript engine, library
@@ -70,17 +71,3 @@
  functions from C code and vice versa.
  .
  This package contains the shared library.
-
-
-
-
-
-
-
-
-
-
-
-
-
-

=== debian/rules ===
--- 
+++ 
@@ -6,14 +6,17 @@
 export DEB_BUILD_MAINT_OPTIONS=noddebs
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_auto_build:
-	make -f Makefile.sharedlibrary
+	mkdir -p tmp-build/lib tmp-build/include
+	make -f Makefile.sharedlibrary install
 	make -f Makefile.cmdline
+	cat debian/duktape.pc.in|sed "s/#TRIPLE#/$(DEB_HOST_MULTIARCH)/g" > debian/duktape.pc
 	dh_auto_build
 
 override_dh_auto_clean:
+	rm -rf tmp-build
 	rm -f duk
 	rm -f libduktaped.so.*
 	rm -f libduktape.so.*

## duktape 2.4.0

=== debian/changelog ===
duktape (2.4.0-1) unstable; urgency=medium

  * New upstream release
  * debian/control: new soname
  * debian/control: set standard to 4.3.0 (no changes)
  * add debian/salsa-ci.yml

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 10 Aug 2019 19:12:02 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper (>=11)
 	, dh-exec
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Homepage: http://duktape.org
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/duktape
 Vcs-Git: https://salsa.debian.org/debian-iot-team/duktape.git
@@ -45,7 +45,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
-	, libduktape203 (= ${binary:Version})
+	, libduktape204 (= ${binary:Version})
 Description: embeddable Javascript engine, development files
  Duktape is an embeddable Javascript engine, with a focus on portability
  and compact footprint.
@@ -56,7 +56,7 @@
  .
  This package contains all source files to use in own projects.
 
-Package: libduktape203
+Package: libduktape204
 Architecture: any
 Multi-Arch: same
 Section: libs

## duktape 2.5.0

=== debugger/Makefile ===
--- 
+++ 
@@ -54,7 +54,7 @@
 	npm install
 
 duk_debug_meta.json:
-	python ../tools/merge_debug_meta.py --output $@ \
+	python2 ../tools/merge_debug_meta.py --output $@ \
 		--class-names duk_classnames.yaml \
 		--opcodes duk_opcodes.yaml \
 		--debug-commands duk_debugcommands.yaml \

=== extras/cbor/Makefile ===
# For manual testing; say 'make' in extras/cbor.

VALGRIND = valgrind
CC = gcc
CCOPTS = -std=c99 -Wall -Wextra -O2
#CCOPTS += -fsanitize=undefined

.PHONY: all
all: clean jsoncbor test-runs

.PHONY: clean
clean:
	-rm -rf ./prep
	-rm -f jsoncbor
	-rm -f appendix_a.json

jsoncbor: jsoncbor.c duk_cbor.c duk_cbor.h
	-rm -rf ./prep
	python2 ../../tools/configure.py --quiet --output-directory ./prep \
		-DDUK_USE_JSON_DECNUMBER_FASTPATH \
		-DDUK_USE_JSON_DECSTRING_FASTPATH \
		-DDUK_USE_JSON_EATWHITE_FASTPATH \
		-DDUK_USE_JSON_QUOTESTRING_FASTPATH \
		-DDUK_USE_JSON_STRINGIFY_FASTPATH
	$(CC) $(CCOPTS) -o $@ -I./prep -I. ./prep/duktape.c duk_cbor.c jsoncbor.c -lm

appendix_a.json:
	wget -O $@ https://raw.githubusercontent.com/cbor/test-vectors/master/appendix_a.json

.PHONY: test-runs
test-runs: jsoncbor \
	enc-primitives enc-number enc-buffer enc-string enc-array enc-object enc-half-float enc-float enc-misc \
	dec-half-float dec-half-float dec-array dec-object

.PHONY: test-vectors
test-vectors: appendix_a.json
	echo "Expects 'duk' to exist in local directory for now..."
	./duk run_testvectors.js

.PHONY: dec-half-float
dec-half-float: jsoncbor
	@echo "half-float zero"
	python -c 'import sys; sys.stdout.write("\xf9\x00\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x00\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x80\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x80\x00")'| $(VALGRIND) -q ./jsoncbor -d
	@echo "half-float denormal"
	python -c 'import sys; sys.stdout.write("\xf9\x00\x01")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x00\x01")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x80\x01")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x80\x01")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x00\x02")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x00\x02")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x80\x02")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x80\x02")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x03\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x03\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x83\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x83\xff")'| $(VALGRIND) -q ./jsoncbor -d
	@echo "half-float normal"
	python -c 'import sys; sys.stdout.write("\xf9\x04\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x04\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x84\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x84\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x07\xfe")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x07\xfe")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x87\xfe")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x87\xfe")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x08\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x08\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x88\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x88\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x78\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x78\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xf8\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xf8\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x7b\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x7b\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xfb\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xfb\xff")'| $(VALGRIND) -q ./jsoncbor -d
	@echo "half-float inf"
	python -c 'import sys; sys.stdout.write("\xf9\x7c\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x7c\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xfc\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xfc\x00")'| $(VALGRIND) -q ./jsoncbor -d
	@echo "half-float nan"
	python -c 'import sys; sys.stdout.write("\xf9\x7c\x01")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x7c\x01")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xfc\x01")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xfc\x01")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x7e\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x7e\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xfe\x00")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xfe\x00")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\x7f\x12")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\x7f\x12")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xf9\xff\x12")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xf9\xff\x12")'| $(VALGRIND) -q ./jsoncbor -d

.PHONY: dec-array
dec-array: jsoncbor
	python -c 'import sys; sys.stdout.write("\x9f\x01\x02\x03\x9f\xff\x04\x80\x80\x9f\x10\x11\xff\x84\x04\x03\x02\x01\xff")' | python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x9f\x01\x02\x03\x9f\xff\x04\x80\x80\x9f\x10\x11\xff\x84\x04\x03\x02\x01\xff")' | $(VALGRIND) -q ./jsoncbor -d

.PHONY: dec-object
dec-object: jsoncbor
	python -c 'import sys; sys.stdout.write("\xbf\x63foo\x63bar\x63bar\xa0\x64quux\xbf\xff\x63baz\xa2\x61a\x61b\x61c\x61d\x65quuux\xbf\x61x\x61y\x61z\x61w\xff\xff")' | python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xbf\x63foo\x63bar\x63bar\xa0\x64quux\xbf\xff\x63baz\xa2\x61a\x61b\x61c\x61d\x65quuux\xbf\x61x\x61y\x61z\x61w\xff\xff")' | $(VALGRIND) -q ./jsoncbor -d

.PHONY: dec-misc
dec-misc: jsoncbor
	python -c 'import sys; sys.stdout.write("\xa1cfoocbar")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xa1cfoocbar")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xa1\xa0\xa0")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xa1\xa0\xa0")'| $(VALGRIND) -q ./jsoncbor -d  # object key, gets string coerced in JSON output
	python -c 'import sys; sys.stdout.write("\x7f\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x7f\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x7f`````````````````````````````````````````````````````````````````````````````````````````````````````````\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x7f`````````````````````````````````````````````````````````````````````````````````````````````````````````\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x7fcfoo\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x7fcfoo\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x7fcfoocbaraqau`auax\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x7fcfoocbaraqau`auax\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x5f\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x5f\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x5f@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x5f@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x5fCfoo\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x5fCfoo\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\x5fCfooCbarAqAu@AuAx\xff")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\x5fCfooCbarAqAu@AuAx\xff")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xc0cfoo")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xc0cfoo")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xc0\xc1cfoo")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xc0\xc1cfoo")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xc0\xd7cfoo")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xc0\xd7cfoo")'| $(VALGRIND) -q ./jsoncbor -d
	python -c 'import sys; sys.stdout.write("\xc0\xd8\xffcfoo")'| python cbordecode.py
	python -c 'import sys; sys.stdout.write("\xc0\xd8\xffcfoo")'| $(VALGRIND) -q ./jsoncbor -d


.PHONY: enc-primitives
enc-primitives: jsoncbor
	echo 'void 0' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo 'null' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo 'true' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo 'false' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py

.PHONY: enc-number
enc-number: jsoncbor
	echo '0' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '0.1' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '1' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '23' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '24' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '25' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '255' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '256' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '65535' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '65536' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '65536.9' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '1048576' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '4294967295' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '4294967296' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py  # shortest encoding: ieee single
	echo '4294967297' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '0xdeadbeef' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '3.141592653589793' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-0' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-0.1' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-1' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-23' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-24' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-25' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-255' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-256' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-257' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-65535' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py
	echo '-65536' | $(VALGRIND) -q ./jsoncbor -r js -w cbor | python2 cbordecode.py

=== extras/logging/Makefile ===
# For manual testing; say 'make' in extras/logging and run ./test.

CC = gcc

.PHONY: test
test:
	-rm -rf ./prep
	python2 ../../tools/configure.py --quiet --output-directory ./prep
	$(CC) -std=c99 -Wall -Wextra -otest -I./prep ./prep/duktape.c duk_logging.c test.c -lm
	./test 'L = new Duktape.Logger(); L.trace("testing"); L.l = 0; L.trace("testing 2");'
	./test 'L = new Duktape.Logger(); L.debug("testing"); L.l = 1; L.debug("testing 2");'
	./test 'L = new Duktape.Logger(); L.info("testing");'
	./test 'L = new Duktape.Logger(); L.warn("testing");'
	./test 'L = new Duktape.Logger(); L.error("testing");'
	./test 'L = new Duktape.Logger(); L.fatal("testing");'
	./test 'L = new Duktape.Logger(); L.info("testing"); L.n = "loggerName"; L.info("new name");'
	./test 'L = new Duktape.Logger("argname"); L.info("testing");'

.PHONY: clean
clean:
	-rm -rf ./prep
	-rm -f test

=== debian/changelog ===
duktape (2.5.0-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 08 Dec 2019 23:26:57 +0000

duktape (2.4.0-2) unstable; urgency=medium

  * Fix FTCBFS: Let dh_auto_build pass cross tools to make.
    Thanks to Helmut Grohne for the patch.
    (Closes: #926608)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 06 Oct 2019 19:12:02 +0200

=== debian/control ===
--- 
+++ 
@@ -45,7 +45,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
-	, libduktape204 (= ${binary:Version})
+	, libduktape205 (= ${binary:Version})
 Description: embeddable Javascript engine, development files
  Duktape is an embeddable Javascript engine, with a focus on portability
  and compact footprint.
@@ -56,7 +56,7 @@
  .
  This package contains all source files to use in own projects.
 
-Package: libduktape204
+Package: libduktape205
 Architecture: any
 Multi-Arch: same
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 override_dh_auto_build:
 	mkdir -p tmp-build/lib tmp-build/include
-	make -f Makefile.sharedlibrary install
-	make -f Makefile.cmdline
+	dh_auto_build --buildsystem=makefile -- -f Makefile.sharedlibrary install
+	dh_auto_build --buildsystem=makefile -- -f Makefile.cmdline
 	cat debian/duktape.pc.in|sed "s/#TRIPLE#/$(DEB_HOST_MULTIARCH)/g" > debian/duktape.pc
 	dh_auto_build

## duktape 2.7.0

=== extras/alloc-pool/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 # For manual testing; say 'make' in extras/alloc-pool and run ./test.
 
-DEFS=
-#DEFS+='-DDUK_ALLOC_POOL_DEBUG'
+CC = gcc
+DEFS =
+#DEFS += '-DDUK_ALLOC_POOL_DEBUG'
 
 .PHONY: test
 test:
@@ -12,7 +13,7 @@
 		--output-directory ./prep \
 		--option-file ./opts.yaml \
 		--fixup-line 'extern void my_fatal(const char *msg);'
-	gcc -std=c99 -Wall -Wextra -m32 -Os -otest \
+	$(CC) -std=c99 -Wall -Wextra -m32 -Os -otest \
 		-I./prep ./prep/duktape.c \
 		$(DEFS) \
 		duk_alloc_pool.c test.c \
@@ -32,7 +33,7 @@
 		--option-file ../../config/examples/low_memory.yaml \
 		--option-file ptrcomp.yaml \
 		--fixup-file ptrcomp_fixup.h
-	gcc -std=c99 -Wall -Wextra -m32 -Os -optrcomptest \
+	$(CC) -std=c99 -Wall -Wextra -m32 -Os -optrcomptest \
 		-I. -I./prep ./prep/duktape.c \
 		$(DEFS) \
 		duk_alloc_pool.c test.c \

=== extras/cbor/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	-rm -f jsoncbor
 	-rm -f appendix_a.json
 
-jsoncbor: jsoncbor.c duk_cbor.c duk_cbor.h
+jsoncbor: jsoncbor.c
 	-rm -rf ./prep
 	python2 ../../tools/configure.py --quiet --output-directory ./prep \
 		-DDUK_USE_JSON_DECNUMBER_FASTPATH \
@@ -22,7 +22,7 @@
 		-DDUK_USE_JSON_EATWHITE_FASTPATH \
 		-DDUK_USE_JSON_QUOTESTRING_FASTPATH \
 		-DDUK_USE_JSON_STRINGIFY_FASTPATH
-	$(CC) $(CCOPTS) -o $@ -I./prep -I. ./prep/duktape.c duk_cbor.c jsoncbor.c -lm
+	$(CC) $(CCOPTS) -o $@ -I./prep -I. ./prep/duktape.c jsoncbor.c -lm
 
 appendix_a.json:
 	wget -O $@ https://raw.githubusercontent.com/cbor/test-vectors/master/appendix_a.json

=== extras/console/Makefile ===
# For manual testing; say 'make' in extras/console and run ./test.

CC = gcc

.PHONY: test
test:
	-rm -rf ./prep
	python2 ../../tools/configure.py --quiet --output-directory ./prep
	$(CC) -std=c99 -Wall -Wextra -o $@ -I./prep -I. ./prep/duktape.c duk_console.c test.c -lm
	./test 'console.assert(true, "not shown");'
	./test 'console.assert(false, "shown", { foo: 123 });'
	./test 'console.log(1, 2, 3, { foo: "bar" });'
	./test 'a={}; b={}; a.ref=b; console.log(a,b); b.ref=a; console.log(a,b)'  # circular ref
	./test 'console.trace(1, 2, 3)'
	./test 'console.dir({ foo: 123, bar: [ "foo", "bar" ]});'

.PHONY: clean
clean:
	-rm -rf ./prep
	-rm -f test

=== extras/minimal-printf/Makefile ===
# Just for manual testing
CC = gcc

.PHONY: test
test: duk_minimal_printf.c
	$(CC) -std=c99 -Wall -Wextra -fno-stack-protector -m32 -Os -fomit-frame-pointer -otest duk_minimal_printf.c test.c
	./test

=== debian/changelog ===
duktape (2.7.0-2) unstable; urgency=medium

  * add -lm to LDFLAGS for libduktape
    (Closes: #1031801)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 25 Feb 2023 12:31:54 +0100

duktape (2.7.0-1) unstable; urgency=medium

  * New upstream release
  * debian/control: set standard to 4.6.0 (no changes)
  * debian/control: set Rules-Requires-Root:

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 21 Feb 2022 18:31:54 +0000

duktape (2.6.0-2) unstable; urgency=medium

  * upload to unstable
  * debian/control: set standard to 4.5.1 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 18 Aug 2021 19:26:34 +0200

duktape (2.6.0-1) experimental; urgency=medium

  * New upstream release
  * debian/control: soname bump
  * debian/control: use dh13

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 06 Aug 2021 23:36:04 +0200

duktape (2.5.0-2) unstable; urgency=medium

  * debian/copyright: update file (Closes: #951903)
  * debian/control: set standard to 4.5.0 (no changes)

  [janitor]
  * Use secure URI in Homepage field.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.4.1, no changes needed.

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 14 Mar 2020 16:44:16 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
-Build-Depends: debhelper (>=11)
+Build-Depends: debhelper-compat (= 13)
 	, dh-exec
-Standards-Version: 4.3.0
-Homepage: http://duktape.org
+Standards-Version: 4.6.0
+Homepage: https://duktape.org
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/duktape
 Vcs-Git: https://salsa.debian.org/debian-iot-team/duktape.git
+Rules-Requires-Root: no
 
 Package: duktape
 Architecture: any
@@ -45,7 +46,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
-	, libduktape205 (= ${binary:Version})
+	, libduktape207 (= ${binary:Version})
 Description: embeddable Javascript engine, development files
  Duktape is an embeddable Javascript engine, with a focus on portability
  and compact footprint.
@@ -56,7 +57,7 @@
  .
  This package contains all source files to use in own projects.
 
-Package: libduktape205
+Package: libduktape207
 Architecture: any
 Multi-Arch: same
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 # does not seem to work here, so no debug stuff
 export DEB_BUILD_MAINT_OPTIONS=noddebs
+export LDFLAGS+=-lm -Wl,--no-as-needed
 
 %:
 	dh $@

## duktape 2.7.0+tests

=== src-tools/Makefile ===
.PHONY: all
all: duktool.js

.PHONY: eslint
eslint:
	npx eslint .

.PHONY: clean
clean:
	-@rm -f duktool.js
	-@rm -rf lib/extdeps

.PHONY: cleanall
cleanall: clean
	-@rm -rf js-yaml
	-@rm -rf from-xml
	-@rm -rf node_modules

.PHONY: reformat
reformat:
	npx js-beautify --quiet --replace `git ls-files | grep -E '*.js$$'`

.PHONY: duktool.js
duktool.js: from-xml js-yaml
	npm install
	mkdir -p lib/extdeps
	cp from-xml/from-xml.js lib/extdeps/from-xml.js
	cp js-yaml/dist/js-yaml.js lib/extdeps/js-yaml.js
	npx webpack
	ls -l duktool.js

from-xml:
	git clone -q https://github.com/svaarala/from-xml

js-yaml:
	git clone -q https://github.com/svaarala/js-yaml

=== src-tools/from-xml/Makefile ===
#!/usr/bin/env bash -c make

SRC=./from-xml.js
TESTS=*.json ./test/*.js
HINTS=$(SRC) $(TESTS)
DIST=./dist
JSDEST=./dist/from-xml.min.js
JSGZIP=./dist/from-xml.min.js.gz

all: test $(JSGZIP)

clean:
	rm -fr $(DIST)

$(DIST):
	mkdir -p $(DIST)

$(JSDEST): $(SRC) $(DIST)
	./node_modules/.bin/uglifyjs $(SRC) -c -m -o $(JSDEST)

$(JSGZIP): $(JSDEST)
	gzip -9 < $(JSDEST) > $(JSGZIP)
	ls -l $(JSDEST) $(JSGZIP)

test: jshint mocha

mocha:
	./node_modules/.bin/mocha -R spec $(TESTS)

jshint:
	./node_modules/.bin/jshint $(HINTS)

.PHONY: all clean test jshint mocha

=== tests/google-v8-benchmark-v7/Makefile ===
# Say 'make' and then just run combined.js.
#
# https://v8.googlecode.com/svn/data/benchmarks/v7/run.html

.PHONY: all
all:	combined.js

base.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/base.js
richards.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/richards.js
deltablue.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/deltablue.js
crypto.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/crypto.js
	patch -p0 < crypto.diff  # needed by mujs
raytrace.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/raytrace.js
earley-boyer.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/earley-boyer.js
	patch -p0 < earley-boyer.diff  # needed by mujs
regexp.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/regexp.js
splay.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/splay.js
navier-stokes.js:
	wget -O $@ http://v8.googlecode.com/svn/data/benchmarks/v7/navier-stokes.js

combined.js: base.js richards.js deltablue.js crypto.js raytrace.js earley-boyer.js regexp.js splay.js navier-stokes.js
	cat base.js richards.js deltablue.js crypto.js raytrace.js earley-boyer.js regexp.js splay.js navier-stokes.js run_harness.js >$@
	wc $@

.PHONY:
clean:
	rm -f base.js richards.js deltablue.js crypto.js raytrace.js earley-boyer.js regexp.js splay.js navier-stokes.js
	rm -f combined.js

=== tests/octane/Makefile ===
# octane/mandreel.js: exceeds const limit at present.
# octane/run.js: not needed, duktape_harness.js handles
# octane/typescript-compiler.js: I/O to be stubbed
# octane/typescript-input.js: -""-
# octane/typescript.js: -""-
# octane/zlib.js: read() dependency
# octane/zlib-data.js: -""-
# octane/regexp.js: checksum error

OCTANEBASE= \
	octane/base.js
TESTS= \
	octane/box2d.js \
	octane/code-load.js \
	octane/crypto.js \
	octane/deltablue.js \
	octane/earley-boyer.js \
	octane/gbemu-part1.js \
	octane/gbemu-part2.js \
	octane/navier-stokes.js \
	octane/pdfjs.js \
	octane/raytrace.js \
	octane/richards.js \
	octane/splay.js

ENGINE=../../duk.O2
#ENGINE=jerry
#ENGINE=mujs

.PHONY: all
all: test

.PHONY: check-engine
check-engine:
	if [ ! -f $(ENGINE) ]; then echo "*** Expected $(ENGINE) to exist"; exit 1; fi

.PHONY: test
test: check-engine octane
	$(ENGINE) $(OCTANEBASE) $(TESTS) duktape_harness.js

# Useful for comparison to other engines when the set of successful sub-tests
# isn't the same; run what can be run.
.PHONY: test-individual
test-individual: octane
	for i in $(TESTS); do echo "*** $$i" ; $(ENGINE) mujs_tweaks.js $(OCTANEBASE) $$i duktape_harness.js; done

octane:
	git clone https://github.com/chromium/octane.git
	touch $@

=== debian/changelog ===
duktape (2.7.0+tests-0ubuntu3) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:56:50 +0200

duktape (2.7.0+tests-0ubuntu2) mantic; urgency=medium

  * debian/patches/disable-tests.patch:
    - include extra tests which are failing on other archs
    
  [ Amin Bandali ]
  * debian/tests:
    - build and run some of the examples as autopkgtests

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 20 Jun 2023 22:01:03 +0200

duktape (2.7.0+tests-0ubuntu1) mantic; urgency=medium

  * Include and run upstream API tests for LP:#1997417.
    - Orig tarball repacked to include missing test files and dependencies.
    - debian/tests: run as autopkgtests.
    - debian/patches/disable-tests.diff: Disable 5 tests that don't pass.

 -- Nathan Pratta Teodosio <nathan.teodosio@canonical.com>  Tue, 20 Jun 2023 13:10:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: duktape
 Section: interpreters
 Priority: optional
-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper-compat (= 13)
 	, dh-exec
